-- Grims Clock is a simple clock to display real time on the game screen
-- Version 3.0 - This should match plugins\dabruddasgrims\GrimsClock.plugin
-- Start with the standard imports
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
-- Import our Variables and bits - should include Vindar
import "DaBruddasGrims.GrimsClock.GrimsClockSettings";
--
-- Lets create the window
--
winGrimsClock=class(Turbine.UI.Window);
--
function winGrimsClock:Constructor()
	Turbine.UI.Window.Constructor( self );
	self:SetSize(190,62);
	self:SetPosition(varGC_Left,varGC_Top);
	self:SetBackColor(Turbine.UI.Color(0,0,0,0)); -- a necessary evil since RoI for some reason. if we don't include this, the window doesn't redraw properly
	self:SetOpacity(varGC_Opacity);
	-- Define the move panel - this is what shows up with CTRL+#
	self.MovePanel=Turbine.UI.Control();
	self.MovePanel:SetParent(self);
	self.MovePanel:SetSize(190,19);
	self.MovePanel:SetBackColor(Turbine.UI.Color(.5,0,0,0));
	-- Define a control to hold the Move Button
	self.Move=Turbine.UI.Control();
	self.Move:SetParent(self.MovePanel);
	self.Move:SetSize(19,19);
	self.Move:SetBackground(picMove_Button);
	self.Move:SetMouseVisible(false);
	-- Define a control to hold the move bar
	self.MoveBar=Turbine.UI.Control();
	self.MoveBar:SetParent(self.MovePanel);
	self.MoveBar:SetSize(19,19);
	self.MoveBar:SetPosition(20,9);
	self.MoveBar:SetBackground(picMove_Bar);
	self.MoveBar:SetMouseVisible(false);
	
	-- Define all the functions to make it movable
	self.MoveX=-1;
	self.MoveY=0;
	self.Moving=false;
--
--	self.MovePanel.MouseDown=function()
--	end
--
	self.MovePanel.MouseClick = function(sender,args)
		if self.Moving then
			self.Moving=false;
			self.MoveX=-1;
		end
	end
--
	self.MovePanel.MouseDown=function(sender,args)
		self.MoveX=args.X;
		self.MoveY=args.Y;
	end
--
	self.MovePanel.MouseUp=function(sender,args)
		self.MoveX=-1;
		self.MoveY=0;
	end
--
	self.MovePanel.MouseEnter=function(sender,args)
		self:SetOpacity(1);
	end
--
	self.MovePanel.MouseLeave=function(sender,args)
		self:SetOpacity(varGC_Opacity);
	end
--
	self.MovePanel.MouseMove=function(sender,args)
		if self.MoveX~=-1 and (args.X~=self.MoveX or args.Y~= self.MoveY) then
			self.Moving=true;
			local newLeft=self:GetLeft()-(self.MoveX-args.X)
			local newTop=self:GetTop()-(self.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
			self:SetPosition(newLeft,newTop);
			varGC_Left = newLeft;
			varGC_Top = newTop;
		end
	end

	-- Defin4 all the bits that will be visible
	self.GrimsClockPanel=Turbine.UI.Control();
	self.GrimsClockPanel:SetParent(self);
	self.GrimsClockPanel:SetBackColor(Turbine.UI.Color(0,0,0,0)); -- so it doesnt show when clock is smaller than 170
	self.GrimsClockPanel:SetPosition(20,0);
	self.GrimsClockPanel:SetSize(170,30);
	-- Left picture
	self.GCLeft=Turbine.UI.Control();
	self.GCLeft:SetParent(self.GrimsClockPanel);
	self.GCLeft:SetSize(35,42);
	self.GCLeft:SetPosition(0,-12);
	self.GCLeft:SetBackground(picLeft_Panel);
	self.GCLeft:SetMouseVisible(false);
	self.GCLeft:SetVisible(true);
	--  Middle picture
	self.GCMid=Turbine.UI.Control();
	self.GCMid:SetParent(self.GrimsClockPanel);
	self.GCMid:SetSize(105,42);
	self.GCMid:SetPosition(35,-12);
	self.GCMid:SetBackground(picMid_Panel);
	self.GCMid:SetMouseVisible(false);
	self.GCMid:SetVisible(true);
--	A label to display the time
	self.GCText=Turbine.UI.Label();
	self.GCText:SetParent(self.GCMid);
	self.GCText:SetSize(105,30);
	self.GCText:SetPosition(0,9);
	self.GCText:SetMultiline(false);
	self.GCText:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	self.GCText:SetText("00:00:00");
	self.GCText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.GCText:SetMouseVisible(false);
	self.GCText:SetVisible(true);
	self.GCText.HScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.GCText.HScrollBar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.GCText.HScrollBar:SetParent(self); -- see if the scrollbar will trigger "IsVisible()" even if it has no parent
	self.GCText.HScrollBar:SetHeight(12);
	self.GCText.HScrollBar:SetPosition(0,-13); -- position it off canvas so it won't ever actually display
	self.GCText:SetHorizontalScrollBar(self.GCText.HScrollBar);
-- right picture
	self.GCRight=Turbine.UI.Control();
	self.GCRight:SetParent(self.GrimsClockPanel);
	self.GCRight:SetSize(35,42);
	self.GCRight:SetPosition(140,-12);
	self.GCRight:SetBackground(picRight_Panel);
	self.GCRight:SetMouseVisible(false);
	self.GCRight:SetVisible(true);
--
	self:SetMouseVisible(false);
--
	self.loaded=false;
	self:SetWantsUpdates(true);
	self:SetWantsKeyEvents(true);
	self.Changed=true;
--
-- This function updates the clock
	self.Update=function()
		local gameTime = Turbine.Engine.GetGameTime()
		local date = Turbine.Engine.GetDate()
		local stringtime = "12:12:12";
		local ampm = "";
		hours, minutes, seconds = date.Hour, date.Minute, date.Second
		if varGC_1224 == 12 then
			if hours >= 12 then
				ampm=" pm";
				hours = hours-12;
			else
				ampm=" am";
			end
			if hours == 0 then
				hours=12;
			end
			if not varGC_AMPM then
				ampm="";
			end
		else
			ampm="";
		end
		hours = string.format("%02d",hours);
		minutes = string.format("%02d",minutes);
		seconds = string.format("%02d",seconds);
		stringtime = hours..":"..minutes
		if varGC_Seconds then
			stringtime = stringtime..":"..seconds
		end
		stringtime = stringtime..ampm;
		if gameTime >= varGC_NextTime then
			varGC_NextTime = Turbine.Engine.GetGameTime() + 1
			self.GCText:SetText(stringtime);
		end
-- Resize the clock panels
		if varGC_1224 == 12 then -- 12 Hour Display
			if varGC_Seconds and varGC_AMPM then
				-- we have 11 characters
				varGC_SizeW = 105;
				varGC_SizeL = 0;
				varGC_SizeM = 35;
				varGC_SizeR = 140;
			elseif varGC_Seconds or varGC_AMPM then
				-- we have 8 characters
				varGC_SizeW = 75;
				varGC_SizeL = 15;
				varGC_SizeM = 50;
				varGC_SizeR = 125;
			else
				-- we have 5 characters
				varGC_SizeW = 47;
				varGC_SizeL = 29;
				varGC_SizeM = 64;
				varGC_SizeR = 111;
			end	
		else -- 24 Hour Display
			if varGC_Seconds then
				-- we have 8 characters
				varGC_SizeW = 75;
				varGC_SizeL = 15;
				varGC_SizeM = 50;
				varGC_SizeR = 125;
			else
				-- we have 5 characters
				varGC_SizeW = 47;
				varGC_SizeL = 29;
				varGC_SizeM = 64;
				varGC_SizeR = 111;
			end
		end
-- Reposition our clock display controls
		self.GCLeft:SetPosition(varGC_SizeL,-12);
		self.GCMid:SetSize(varGC_SizeW,42);
		self.GCMid:SetPosition(varGC_SizeM,-12);
		self.GCText:SetSize(varGC_SizeW,30);
		self.GCRight:SetPosition(varGC_SizeR,-12);		
		if not self.loaded then
			self.loaded=true;
			Plugins["GrimsClock"].Unload = function(self,sender,args)
				UnloadGrimsClock();
			end
			self:SetWantsUpdates(true);
		end
	end
-- Define a function to capture Mouse Right Click and swap the visibility of the Menu
	self.GrimsClockPanel.MouseClick=function(sender,args)
		if args.Button==2 then
			self.MenuPanel:SetVisible(true); -- Open the Menu Panel
			varGC_MenuVisible=true;
		end
	end
--
	self.KeyDown=function(sender, args)
		if ( args.Action == 268435579 ) then -- reposition UI
			GrimsClockMoveToggle=not GrimsClockMoveToggle;
			GrimsClockWindow.MovePanel:SetVisible(GrimsClockMoveToggle);
		end
		if ( args.Action == 268435635 ) then -- toggle HUD
			GrimsClockHUDState = not GrimsClockHUDState;
			if GrimsClockHUDState then
				GrimsClockWindow:SetVisible(GrimsClockMainState);
			else
				GrimsClockMainState=GrimsClockWindow:IsVisible();
				GrimsClockWindow:SetVisible(false);
			end
		end
	end
--
	self.playerAttributes=localPlayer:GetAttributes();
--
-- Display Options popup
	self.MenuPanel=Turbine.UI.Lotro.Window();
	self.MenuPanel:SetSize(260,145);
	self.MenuPanel:SetPosition(self:GetLeft(),self:GetTop()); -- this should get overridden when mouse is clicked
	self.MenuPanel:SetZOrder(self:GetZOrder()+1);
	self.MenuPanel:SetBackColor(Turbine.UI.Color(0,0,0,0));
	self.MenuPanel:SetText(txtTitle);
-- Create a control to hold 12/24 Hour choice
	self.con1224=Turbine.UI.Control();
	self.con1224:SetParent(self.MenuPanel);
	self.con1224:SetSize(220,20);
	self.con1224:SetPosition(20,40);
-- Label 12 Hour
	self.lab12=Turbine.UI.Label();
	self.lab12:SetParent(self.con1224);
	self.lab12:SetSize(80,20);
	self.lab12:SetPosition(0,0);
	self.lab12:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.lab12:SetText(txt12);
	self.lab12:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	self.lab12:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.lab12:SetMouseVisible(false);
	self.lab12:SetVisible(true);
-- Radio Button 12 Hour
	self.rb12=Turbine.UI.Control();
	self.rb12:SetParent(self.con1224);
	self.rb12:SetSize(16,16);
	self.rb12:SetPosition(82,3);
	self.rb12:SetBlendMode(Turbine.UI.BlendMode.Overlay);
-- Label 24 Hour
	self.lab24=Turbine.UI.Label();
	self.lab24:SetParent(self.con1224);
	self.lab24:SetSize(80,20);
	self.lab24:SetPosition(120,0);
	self.lab24:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.lab24:SetText(txt24);
	self.lab24:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	self.lab24:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.lab24:SetMouseVisible(false);
	self.lab24:SetVisible(true);
-- Radio Button 24 Hour
	self.rb24=Turbine.UI.Control();
	self.rb24:SetParent(self.con1224);
	self.rb24:SetSize(16,16);
	self.rb24:SetPosition(202,3);
	self.rb24:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.rb24:SetMouseVisible(false);
-- Set the radio buttons depending on loaded varaibles
	if varGC_1224 == 12 then
		self.rb12:SetBackground(picRB_Selected);
		self.rb24:SetBackground(picRB_UnSelected);
	else
		self.rb12:SetBackground(picRB_UnSelected);
		self.rb24:SetBackground(picRB_Selected);
	end
-- If the control is clicked then swap selections
	self.con1224.MouseClick=function()
		if varGC_1224 == 24 then
			varGC_1224 = 12;
			self.rb12:SetBackground(picRB_Selected);
			self.rb24:SetBackground(picRB_UnSelected);
		else
			varGC_1224 = 24;
			self.rb12:SetBackground(picRB_UnSelected);
			self.rb24:SetBackground(picRB_Selected);
		end
	end
-- Create a control to hold AM/PM Hour choice
	self.conAMPM=Turbine.UI.Control();
	self.conAMPM:SetParent(self.MenuPanel);
	self.conAMPM:SetSize(220,20);
	self.conAMPM:SetPosition(20,60);
-- Label AM/PM
	self.labAMPM=Turbine.UI.Label();
	self.labAMPM:SetParent(self.conAMPM);
	self.labAMPM:SetSize(80,20);
	self.labAMPM:SetPosition(0,0);
	self.labAMPM:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.labAMPM:SetText(txtAMPM);
	self.labAMPM:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	self.labAMPM:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.labAMPM:SetMouseVisible(false);
	self.labAMPM:SetVisible(true);
-- Radio Button AM/PM
	self.rbAMPM=Turbine.UI.Control();
	self.rbAMPM:SetParent(self.conAMPM);
	self.rbAMPM:SetSize(16,16);
	self.rbAMPM:SetPosition(82,3);
	self.rbAMPM:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.rbAMPM:SetMouseVisible(false);
-- Label None
	self.labNone=Turbine.UI.Label();
	self.labNone:SetParent(self.conAMPM);
	self.labNone:SetSize(80,20);
	self.labNone:SetPosition(120,0);
	self.labNone:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.labNone:SetText(txtNone);
	self.labNone:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	self.labNone:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.labNone:SetMouseVisible(false);
	self.labNone:SetVisible(true);
-- Radio Button None
	self.rbNone=Turbine.UI.Control();
	self.rbNone:SetParent(self.conAMPM);
	self.rbNone:SetSize(16,16);
	self.rbNone:SetPosition(202,3);
	self.rbNone:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.rb24:SetMouseVisible(false);
-- Set the radio buttons depending on loaded varaibles
	if varGC_AMPM then
		self.rbAMPM:SetBackground(picRB_Selected);
		self.rbNone:SetBackground(picRB_UnSelected);
	else
		self.rbAMPM:SetBackground(picRB_UnSelected);
		self.rbNone:SetBackground(picRB_Selected);
	end
-- If the control is clicked then swap selections
	self.conAMPM.MouseClick=function()
		if varGC_AMPM == true then
			varGC_AMPM=false;
			self.rbAMPM:SetBackground(picRB_UnSelected);
			self.rbNone:SetBackground(picRB_Selected);
		else
			varGC_AMPM=true;
			self.rbAMPM:SetBackground(picRB_Selected);
			self.rbNone:SetBackground(picRB_UnSelected);
		end
	end
--	
-- Create a control to hold Seconds choice
	self.conSecs=Turbine.UI.Control();
	self.conSecs:SetParent(self.MenuPanel);
	self.conSecs:SetSize(220,20);
	self.conSecs:SetPosition(20,80);
-- Label AM/PM
	self.labSecs=Turbine.UI.Label();
	self.labSecs:SetParent(self.conSecs);
	self.labSecs:SetSize(80,20);
	self.labSecs:SetPosition(0,0);
	self.labSecs:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.labSecs:SetText("HH:MM:SS");
	self.labSecs:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	self.labSecs:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.labSecs:SetMouseVisible(false);
	self.labSecs:SetVisible(true);
-- Radio Button AM/PM
	self.rbSecs=Turbine.UI.Control();
	self.rbSecs:SetParent(self.conSecs);
	self.rbSecs:SetSize(16,16);
	self.rbSecs:SetPosition(82,3);
	self.rbSecs:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.rbSecs:SetMouseVisible(false);
-- Label None
	self.labNoSec=Turbine.UI.Label();
	self.labNoSec:SetParent(self.conSecs);
	self.labNoSec:SetSize(80,20);
	self.labNoSec:SetPosition(120,0);
	self.labNoSec:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.labNoSec:SetText("HH:MM");
	self.labNoSec:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	self.labNoSec:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.labNoSec:SetMouseVisible(false);
	self.labNoSec:SetVisible(true);
-- Radio Button None
	self.rbNoSec=Turbine.UI.Control();
	self.rbNoSec:SetParent(self.conSecs);
	self.rbNoSec:SetSize(16,16);
	self.rbNoSec:SetPosition(202,3);
	self.rbNoSec:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.rb24:SetMouseVisible(false);
-- Set the radio buttons depending on loaded varaibles
	if varGC_Seconds then
		self.rbSecs:SetBackground(picRB_Selected);
		self.rbNoSec:SetBackground(picRB_UnSelected);
	else
		self.rbSecs:SetBackground(picRB_UnSelected);
		self.rbNoSec:SetBackground(picRB_Selected);
	end
-- If the control is clicked then swap selections
	self.conSecs.MouseClick=function()
		if varGC_Seconds == true then
			varGC_Seconds=false;
			self.rbSecs:SetBackground(picRB_UnSelected);
			self.rbNoSec:SetBackground(picRB_Selected);
		else
			varGC_Seconds=true;
			self.rbSecs:SetBackground(picRB_Selected);
			self.rbNoSec:SetBackground(picRB_UnSelected);
		end
	end
-- Divider Bar
	self.Divider=Turbine.UI.Control();
	self.Divider:SetParent(self.MenuPanel);
	self.Divider:SetSize(220,10);
	self.Divider:SetPosition(20,100);
	self.Divider:SetMouseVisible(false);	
	self.Divider:SetBackground(picBar_Horizontal);
-- Label Opacity
	self.labOpacity=Turbine.UI.Label();
	self.labOpacity:SetParent(self.MenuPanel);
	self.labOpacity:SetSize(220,20);
	self.labOpacity:SetPosition(20,110);
	self.labOpacity:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.labOpacity:SetText(txtOpacity);
	self.labOpacity:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	self.labOpacity:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.labOpacity:SetMouseVisible(false);
	self.labOpacity:SetVisible(true);
-- Opacity Scroll Bar	
	self.OpacityScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.OpacityScrollBar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.OpacityScrollBar:SetParent(self.MenuPanel);
	self.OpacityScrollBar:SetSize(220,10);
	self.OpacityScrollBar:SetPosition(20,120);
	self.OpacityScrollBar:SetMinimum(1);
	self.OpacityScrollBar:SetMaximum(100);
	self.OpacityScrollBar:SetValue(varGC_Opacity*100);
-- Function to read Opacity
	self.OpacityScrollBar.ValueChanged=function()
		varGC_Opacity=self.OpacityScrollBar:GetValue()/100;
		self:SetOpacity(varGC_Opacity);
	end
--
end
--
GrimsClockWindow=winGrimsClock()
GrimsClockWindow:SetVisible(true);
GrimsClockWindow.MovePanel:SetVisible(false);
Turbine.Shell.WriteLine("GrimsClock "..Plugins["GrimsClock"]:GetVersion().." loaded. Right click for menu");