-- Grims Clock is a simple clock to display real time on the game screen
-- Version 3.0 - This should match plugins\dabruddasgrims\GrimsClock.plugin
-- Settings, Language, Load Saved Variables and Save Variable on Unload
--import "Turbine";
--import "Turbine.UI";
--import "Turbine.UI.Lotro";
--import "Turbine.Gameplay";
-- Vindar Patch to fix Euro Client Issue
--
import "DaBruddasGrims.GrimsClock.VindarPatch";
--
-- Set our default variables
--
varGC_Top=300; -- X position
varGC_Left=300; -- Y position
varGC_1224=24;
varGC_AMPM=false;
varGC_Seconds=true;
varGC_Opacity=.6; -- Opacity
varGC_NextTime = 0; -- used in update function
varGC_MenuVisible=false;
varGC_SizeW = 105; -- Width of middle panel
varGC_SizeL = 0; -- Position of left panel
varGC_SizeM = 35; -- Position of middle panel
varGC_SizeR = 140; -- Position of right panel
--
GrimsClockHUDState=true;
GrimsClockMainState=true;
GrimsClockMoveToggle=false;
localPlayer=Turbine.Gameplay.LocalPlayer:GetInstance();
--
-- Define pictures for the Radio Buttons
--
picMove_Button=("DaBruddasGrims/GrimsClock/Resources/picGC_Button.tga");
picMove_Bar=("DaBruddasGrims/GrimsClock/Resources/picGC_Bar.tga");
picLeft_Panel=("DaBruddasGrims/GrimsClock/Resources/picGC_Left.tga");
picMid_Panel=("DaBruddasGrims/GrimsClock/Resources/picGC_Mid.tga");
picRight_Panel=("DaBruddasGrims/GrimsClock/Resources/picGC_Right.tga");
picBar_Horizontal=("DaBruddasGrims/GrimsClock/Resources/picGC_Horizontal.jpg");
picRB_Selected=("DaBruddasGrims/GrimsClock/Resources/picGC_RB_Selected.tga");
picRB_UnSelected=("DaBruddasGrims/GrimsClock/Resources/picGC_RB_UnSelected.tga");
--
-- Check for Language Settings and adjust Menu text items
--
varGC_Locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	varGC__Locale = "de";
elseif Turbine.Shell.IsCommand("aide") then
	varGC_Locale = "fr";
end
--
if varGC_Locale=="en" then
	txtTitle="Clock Menu";
	txt12="12 Hour";
	txt24="24 Hour";
	txtAMPM="AM/PM";
	txtNone="None";
	txtOpacity="Opacity"
elseif varGC_Locale=="de" then
	txtTitle="Uhr-Men";
	txt12="12 Stunde";
	txt24="24 Stunde";
	txtAMPM="AM/PM";
	txtNone="Keiner";
	txtOpacity="Opazitt"
elseif varGC_Locale=="fr" then
	txtTitle="Horloge"; -- "Menu de l'Horloge" does not fit in titlebar
	txt12="12 Heure";
	txt24="24 Heure";
	txtAMPM="AM/PM";
	txtNone="Aucun";
	txtOpacity="Opacit"
end
--
-- Create a function to load our saved variables
--
LoadSettings=function()
	local settings=PatchDataLoad( Turbine.DataScope.Character, "GrimsClock_Settings");
	if settings~=nil then
		local tmpIndex;
		for tmpIndex=1,#settings do
			if settings[tmpIndex][1]=="Top" then
				varGC_Top=settings[tmpIndex][2];
			elseif settings[tmpIndex][1]=="Left" then
				varGC_Left=settings[tmpIndex][2];
			elseif settings[tmpIndex][1]=="1224" then
				varGC_1224=settings[tmpIndex][2];
			elseif settings[tmpIndex][1]=="AMPM" then
				varGC_AMPM=settings[tmpIndex][2];
			elseif settings[tmpIndex][1]=="Seconds" then
				varGC_Seconds=settings[tmpIndex][2];
			elseif settings[tmpIndex][1]=="Opacity" then
				varGC_Opacity=settings[tmpIndex][2];
			end
		end
	end
end
-- Run the function to load our saved variables
LoadSettings()
--
-- Unload and Save Settings
--
function UnloadGrimsClock()
	Turbine.Shell.WriteLine("GrimsClock "..Plugins["GrimsClock"]:GetVersion().." unloaded");
	local Settings={};
	Settings[#Settings+1]={"Top",GrimsClockWindow:GetTop()};
	Settings[#Settings+1]={"Left",GrimsClockWindow:GetLeft()};
	Settings[#Settings+1]={"1224",varGC_1224};	
	Settings[#Settings+1]={"AMPM",varGC_AMPM};
	Settings[#Settings+1]={"Seconds",varGC_Seconds};
	Settings[#Settings+1]={"Opacity",varGC_Opacity};
	PatchDataSave( Turbine.DataScope.Character, "GrimsClock_Settings", Settings );
end
